# Raphaël Boudreault/Improved CP-Based Lagrangian Relaxation Approach with an Application to the TSP (IJCAI 2021)

import re
import sys
import ntpath

if len(sys.argv) != 2:
    print("Usage: python3 name.py output.txt")
    exit()

filename = sys.argv[1]
with open(filename) as file:
    content = file.read()

match = re.search('obj = ([0-9]+)(?:.*)Resolution time ([0-9.]+)(?:.*) ([0-9.]+) Nodes', content)

if match:
    obj = match[1]
    time = float(match[2])
    nodes = int(match[3])
    print(ntpath.basename(filename).replace('.txt', ''), nodes, time, obj, sep=', ')
else:
    print(ntpath.basename(filename).replace('.txt', ''), ", Timeout")
